unit phTreeEditor;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  {$ifdef D6}
  DesignIntf,DesignEditors;
  {$else}
  DsgnIntf;
  {$endif}


type

  TphTreeEditorWakeUpGlue = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;



implementation
uses
  phTree_BA,BoldNodeControlPack,Dialogs,phTreeNodeDescriptionEditor;



{ TphNodeDescriptionEditor }

procedure TphTreeEditorWakeUpGlue.ExecuteVerb(Index: Integer);
begin
  TTreeNodeDescriptionEditor.Edit(Component,(Component as TphTree_BA).BoldProperties, Designer);
  Designer.Modified;
end;

function TphTreeEditorWakeUpGlue.GetVerb(Index: Integer): string;
begin
  Result := '&Edit Node Descriptions...';
end;

function TphTreeEditorWakeUpGlue.GetVerbCount: Integer;
begin
  Result := 1;
end;


end.

