unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  BoldHandle, BoldUMLModelLink, BoldUMLRose98Link, BoldAbstractModel,
  BoldModel, BoldHandles, BoldSubscription, BoldSystemHandle,
  phOffscreenPaint, phBabGridView, phGrid, phGrid_BA, ExtCtrls, phGant,
  phGant_BA, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    BoldSystemHandle1: TBoldSystemHandle;
    BoldSystemTypeInfoHandle1: TBoldSystemTypeInfoHandle;
    BoldModel1: TBoldModel;
    BoldUMLRose98Link1: TBoldUMLRose98Link;
    phGant_BA1: TphGant_BA;
    phGrid_BA1: TphGrid_BA;
    PopupMenu1: TPopupMenu;
    AddTreeItem1: TMenuItem;
    RemoveTreeItem1: TMenuItem;
    N1: TMenuItem;
    AddTimeItemLayer1: TMenuItem;
    RemoveTimeItem1: TMenuItem;
    AddTimeItemLayer0: TMenuItem;
    procedure AddTreeItem1Click(Sender: TObject);
    procedure RemoveTreeItem1Click(Sender: TObject);
    procedure RemoveTimeItem1Click(Sender: TObject);
    procedure AddTimeItemLayer1Click(Sender: TObject);
    procedure AddTimeItemLayer0Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
  private
    procedure AddTimeItemOnLayer(i: integer);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses BATestClasses;

{$R *.DFM}

var
  g:integer=0;
procedure TForm1.AddTreeItem1Click(Sender: TObject);
var
  ti:TTreeItem;
begin
  ti:=TTreeItem.Create(nil);
  inc(g);
  ti.Text:='<newitem>'+IntToStr(g);
  ti.LayerItems.AddNew.IndexNo:=0;
  ti.LayerItems.AddNew.IndexNo:=1;
  if PopupMenu1.PopupComponent=phGant_BA1.TreeView then
  begin
    if Assigned(phGant_BA1.TreeView.CurrentDataEntity) then
    begin
      ti.TreeItem:=phGant_BA1.DataEntityToElement(phGant_BA1.TreeView.CurrentDataEntity) as TTreeItem;
    end;
  end
  else
  if PopupMenu1.PopupComponent=phGrid_BA1 then
  begin
    ti.TreeItem:=phGrid_BA1.GetFirstSelectedObject as TTreeItem;
  end;
end;

procedure TForm1.RemoveTreeItem1Click(Sender: TObject);
var
  ti:TTreeItem;
begin
  ti:=nil;
  if PopupMenu1.PopupComponent=phGant_BA1.TreeView then
  begin
    if Assigned(phGant_BA1.TreeView.CurrentDataEntity) then
    begin
      ti:=phGant_BA1.DataEntityToElement(phGant_BA1.TreeView.CurrentDataEntity) as TTreeItem;
    end;
  end
  else
  if PopupMenu1.PopupComponent=phGrid_BA1 then
  begin
    ti:=phGrid_BA1.GetFirstSelectedObject as TTreeItem;
  end;

  if Assigned(ti) then
  begin
    ti.UnLinkAll;
    ti.Delete;
  end;

end;

procedure TForm1.AddTimeItemOnLayer(i:integer);
var
  ti:TTreeItem;
  time:TTimeItem;
  gr:TGantRow;
begin
  gr:=phGant_BA1.RowList.FindRowFromY(phGant_BA1.GantMousePosition.y);
  if Assigned(gr)  then
  begin
    ti:=phGant_BA1.DataEntityToElement(gr.TreeNode) as TTreeItem;
    time:=TTimeItem.Create(nil);
    time.Start:=phGant_BA1.DateScaler.PixelToDate(phGant_BA1.GantMousePosition.x);
    time.Stop:=time.Start+2;
    time.LayerItem:=ti.LayerItems[i];
  end;
end;

procedure TForm1.RemoveTimeItem1Click(Sender: TObject);
var
  time:TTimeItem;
begin
  if PopupMenu1.PopupComponent=phGant_BA1.GA then
  begin
    if Assigned(phGant_BA1.ActiveDataEntity) then
    begin
      time:=phGant_BA1.DataEntityToElement(phGant_BA1.ActiveDataEntity) as TTimeItem;
      time.UnLinkAll;
      time.Delete;
    end;
  end;
end;

procedure TForm1.AddTimeItemLayer0Click(Sender: TObject);
begin
  if PopupMenu1.PopupComponent=phGant_BA1.GA then
    AddTimeItemOnLayer(0);
end;

procedure TForm1.AddTimeItemLayer1Click(Sender: TObject);
begin
  if PopupMenu1.PopupComponent=phGant_BA1.GA then
    AddTimeItemOnLayer(1);
end;


procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  AddTreeItem1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.TreeView) or (PopupMenu1.PopupComponent=phGrid_BA1);
  RemoveTreeItem1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.TreeView) or (PopupMenu1.PopupComponent=phGrid_BA1);
  AddTimeItemLayer0.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.GA);
  AddTimeItemLayer1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.GA);
  RemoveTimeItem1.Enabled:=(PopupMenu1.PopupComponent=phGant_BA1.GA) and Assigned(phGant_BA1.ActiveDataEntity);
end;

end.
