unit phBabGridEditors;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  {$ifdef D6}
  DesignIntf,DesignEditors;
  {$else}
  DsgnIntf;
  {$endif}

type

  TphBabNodeDescriptionEditorWakeUpGlue = class(TComponentEditor)
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;



implementation
uses
  phBabGridView_BA,BoldNodeControlPack,Dialogs,phTreeNodeDescriptionEditor;



{ TphNodeDescriptionEditor }

procedure TphBabNodeDescriptionEditorWakeUpGlue.ExecuteVerb(Index: Integer);
begin
  TTreeNodeDescriptionEditor.Edit(Component,(Component as TBabGridView_BA).BoldProperties, Designer);
  Designer.Modified;
end;

function TphBabNodeDescriptionEditorWakeUpGlue.GetVerb(Index: Integer): string;
begin
  Result := '&Edit Node Descriptions...';
end;

function TphBabNodeDescriptionEditorWakeUpGlue.GetVerbCount: Integer;
begin
  Result := 1;
end;



end.

